
(require-library cells simple-tests)
(import cells chicken simple-tests)

(define (push st% val)
  (st% (cons val (st%))))
(define (top st%)
  (car (st%)))
(define (pop st%)
  (st% (cdr (st%))))

(define-test (CELLS)
  (check
    (define cl (cell 5))
    (cell? cl)
    (not (cell? 5))
    ((cell-of? number?) cl)
    (not ((cell-of? list?) cl))
    (= (cell-ref cl) 5)
    (cell-set! cl 50)
    (= (cell-ref cl) 50)
    (cell-set! cl 500)
    (= (cell-ref cl) 500)
    (not (condition-case (cell-ref 500)
           ((exn) #f)))
    (define cl% (cell->closure cl))
    (cl%) ; -> 500
    (cl% 5)
    (cl%) ; -> 500
    ))

(define-test (STACKS)
  (check
    (define stack (cell '()));'#,(% ()))
    (cell? stack)
    ((cell-of? list?) stack)
    (not ((cell-of? number?) stack))
    (define stack% (cell->closure stack))
    (null? (stack%))
    (push stack% 5)
    (push stack% 50)
    (push stack% 500)
    (= 500 (top stack%))
    (pop stack%)
    (= 50 (top stack%))
    (pop stack%)
    (= 5 (top stack%))))

(compound-test (cells)
  (CELLS)
  (STACKS)
  )
  
